﻿#include "ExportMethod.h"

#include <future>

#include "ProtocolDecodeBase.h"
#include "EdgePulseData.h"
#include "QuantizeParams.h"
#include "ProtocolRS232/Protocol.RS232.Options.h"
#include "ProtocolRS232/RS232DecodeResult.h"
#include "ProtocolUSB/UsbDecodeOptions.h"
#include "ProtocolUSB/USBDecodeResult.h"


namespace Protocol
{
    extern "C" {

    LIBMATH_API bool Parse_USB(UsbDecodeOptions option, std::vector<Protocol::TwoLevelEdgePulse> edgePluses1,
                               std::vector<Protocol::TwoLevelEdgePulse> edgePluses2, UsbDecodeResult& result);


    LIBMATH_API bool Parse_RS232(const ProtocolRS232Options& options,
                                 const EdgePulseDataTwoLevels& edgePulseData,
                                 RS232DecodeResult& decodeResult);

    // LIBMATH_API bool quantizeParamsDecodeRS232(const QuantizeParams& quantizeParams,
    //                                            const ProtocolRS232Options& options,
    //                                            RS232DecodeResult& decodeResult);


    inline LIBMATH_API void setCancellationSignal(bool value)
    {
        canceled = value;
    }

    LIBMATH_API void getVersionExport(uint8_t* version);

    }
}
